//
//  ASObject.h
//  Paste2
//
//  Created by Andrew Finnell on 10/28/09.
//  Copyright 2009 Order N Development, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class ASElementArray;

extern NSString * const ASObjectAppleScriptException;

@interface ASObject : NSObject {
	NSScriptObjectSpecifier	*_specifier;
}

+ (id) makeNewClass:(Class)theClass withProperties:(NSDictionary *)properties withData:(id)data inContainer:(ASElementArray *)container atIndex:(int)index;

- (id) initWithScriptObjectSpecifier:(NSScriptObjectSpecifier *)specifier;

- (NSScriptClassDescription *) scriptClassDescription;

- (ASElementArray *) elementForKey:(NSString *)string;

- (void) setObject:(id)value forProperty:(NSString *)property;
- (id) objectForProperty:(NSString *)property;

- (void) delete;

+ (id) invokeCommand:(NSString *)name withParameters:(NSDictionary *)parameters;
+ (id) invokeCommand:(NSString *)name inSuite:(NSString *)suiteName onObject:(ASObject *)object withParameters:(NSDictionary *)parameters;
+ (id) invokeCommand:(NSString *)name with:(id)firstObject, ...;
+ (id) invokeCommand:(NSString *)name;

- (id) invokeCommand:(NSString *)name withParameters:(NSDictionary *)parameters;
- (id) invokeCommand:(NSString *)name with:(id)firstObject, ...;
- (id) invokeCommand:(NSString *)name;

@end

ASObject *ASObj(id obj);
NSString *NSStringFromAppleEvent(AppleEvent event);
